Package serp.bytecode

# Class ConstantInstruction

java.lang.Object
serp.bytecode.Instruction
serp.bytecode.TypedInstruction
serp.bytecode.ConstantInstruction

All Implemented Interfaces:
  `BCEntity`, `VisitAcceptor`

public class ConstantInstruction extends TypedInstruction
An instruction that that loads a constant onto the stack. The opcode represented by this instruction may change depending on the type and value of the constant set. For example, if the constant value is initially set to 5, the opcode will be `iconst5`; if later incremented to 6, the opcode will be changed to `bipush(6)`.

Author:
  Abe White

## Method Summary

Modifier and Type
Method
Description
`void`
`acceptVisit(BCVisitor visit)`
Accept a visit from a `BCVisitor`, calling the appropriate methods to notify the visitor that it has entered this entity, and to provide it with the proper callbacks for each sub-entity owned by this one.
`boolean`
`equalsInstruction(Instruction other)`
ConstantInstructions are equal if the const they reference is the same, or if the const of either is unset.
`String`
`getClassNameValue()`
Return the class value of this constant, or null if not set.
`double`
`getDoubleValue()`
Return the double value of this constant, or 0 if not set.
`float`
`getFloatValue()`
Return the float value of this constant, or 0 if not set.
`int`
`getIntValue()`
Return the int value of this constant, or 0 if not set.
`int`
`getLogicalStackChange()`
Return the logical number of stack positions changed by this instruction.
`long`
`getLongValue()`
Return the long value of this constant, or 0 if not set.
`int`
`getStackChange()`
Return the number of stack positions this instruction pushes or pops during its execution.
`String`
`getStringValue()`
Return the string value of this constant, or null if not set.
`String`
`getTypeName()`
Return the type name for this instruction.
`Object`
`getValue()`
Return the value of the constant as its wrapper type, or null if not set.
`ConstantInstruction`
`setNull()`
Set this constant to null.
`TypedInstruction`
`setType(String type)`
Set the type of this instruction.
`ConstantInstruction`
`setValue(boolean value)`
Set the value of this constant; note that this type is converted to int.
`ConstantInstruction`
`setValue(char value)`
Set the value of this constant; note that this type is converted to int.
`ConstantInstruction`
`setValue(double value)`
Set the value of this constant.
`ConstantInstruction`
`setValue(float value)`
Set the value of this constant.
`ConstantInstruction`
`setValue(int value)`
Set the value of this constant.
`ConstantInstruction`
`setValue(long value)`
Set the value of this constant.
`ConstantInstruction`
`setValue(short value)`
Set the value of this constant; note that this type is converted to int.
`ConstantInstruction`
`setValue(Class value)`
Set the value of this constant.
`ConstantInstruction`
`setValue(Object value)`
Set the constant to the given value.
`ConstantInstruction`
`setValue(String value)`
Set the value of this constant.
`ConstantInstruction`
`setValue(String value, boolean clsName)`
`ConstantInstruction`
`setValue(BCClass value)`
Set the value of this constant.

### Methods inherited from class serp.bytecode.TypedInstruction

`getType, getTypeBC, setType, setType`

### Methods inherited from class serp.bytecode.Instruction

`getByteIndex, getClassLoader, getCode, getLineNumber, getName, getOpcode, getPool, getProject, isValid`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### getStackChange

public int getStackChange()
Description copied from class: `Instruction`
Return the number of stack positions this instruction pushes or pops during its execution.

Overrides:
  `getStackChange` in class `Instruction`
Returns:
  0 if the stack is not affected by this instruction, a positive number if it pushes onto the stack, and a negative number if it pops from the stack

### getLogicalStackChange

public int getLogicalStackChange()
Description copied from class: `Instruction`
Return the logical number of stack positions changed by this instruction. In other words, ignore weirdness with longs and doubles taking two stack positions.

Overrides:
  `getLogicalStackChange` in class `Instruction`

### getTypeName

public String getTypeName()
Description copied from class: `TypedInstruction`
Return the type name for this instruction. If the type has not been set, this method will return null.

Specified by:
  `getTypeName` in class `TypedInstruction`

### setType

public TypedInstruction setType(String type)
Description copied from class: `TypedInstruction`
Set the type of this instruction. Types that have no direct support will be converted accordingly.

Specified by:
  `setType` in class `TypedInstruction`
Returns:
  this instruction, for method chaining

### getValue

public Object getValue()
Return the value of the constant as its wrapper type, or null if not set. Returns class values as the class name.

### setValue

public ConstantInstruction setValue(Object value)
Set the constant to the given value. The value should be an instance of String, Integer, Long, Double, Float, Class, BCClass, or null depending on the constant type. If the given value is not supported directly, it will be converted accordingly.

Returns:
  this instruction, for method chaining

### getStringValue

public String getStringValue()
Return the string value of this constant, or null if not set.

### getIntValue

public int getIntValue()
Return the int value of this constant, or 0 if not set.

### getLongValue

public long getLongValue()
Return the long value of this constant, or 0 if not set.

### getFloatValue

public float getFloatValue()
Return the float value of this constant, or 0 if not set.

### getDoubleValue

public double getDoubleValue()
Return the double value of this constant, or 0 if not set.

### getClassNameValue

public String getClassNameValue()
Return the class value of this constant, or null if not set.

### setNull

public ConstantInstruction setNull()
Set this constant to null.

Returns:
  this instruction, for method chaining

### setValue

public ConstantInstruction setValue(String value)
Set the value of this constant.

Returns:
  this instruction, for method chaining

### setValue

public ConstantInstruction setValue(String value, boolean clsName)

### setValue

public ConstantInstruction setValue(Class value)
Set the value of this constant.

Returns:
  this instruction, for method chaining

### setValue

public ConstantInstruction setValue(BCClass value)
Set the value of this constant.

Returns:
  this instruction, for method chaining

### setValue

public ConstantInstruction setValue(int value)
Set the value of this constant.

Returns:
  this instruction, for method chaining

### setValue

public ConstantInstruction setValue(long value)
Set the value of this constant.

Returns:
  this instruction, for method chaining

### setValue

public ConstantInstruction setValue(float value)
Set the value of this constant.

Returns:
  this instruction, for method chaining

### setValue

public ConstantInstruction setValue(double value)
Set the value of this constant.

Returns:
  this instruction, for method chaining

### setValue

public ConstantInstruction setValue(boolean value)
Set the value of this constant; note that this type is converted to int.

Returns:
  this instruction, for method chaining

### setValue

public ConstantInstruction setValue(short value)
Set the value of this constant; note that this type is converted to int.

Returns:
  this instruction, for method chaining

### setValue

public ConstantInstruction setValue(char value)
Set the value of this constant; note that this type is converted to int.

Returns:
  this instruction, for method chaining

### equalsInstruction

public boolean equalsInstruction(Instruction other)
ConstantInstructions are equal if the const they reference is the same, or if the const of either is unset.

Overrides:
  `equalsInstruction` in class `Instruction`

### acceptVisit

public void acceptVisit(BCVisitor visit)
Description copied from interface: `VisitAcceptor`
Accept a visit from a `BCVisitor`, calling the appropriate methods to notify the visitor that it has entered this entity, and to provide it with the proper callbacks for each sub-entity owned by this one.

Specified by:
  `acceptVisit` in interface `VisitAcceptor`
Overrides:
  `acceptVisit` in class `Instruction`